VERSION 5.00
Begin VB.UserControl MsgScroller 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ClipControls    =   0   'False
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "MsgScroller.ctx":0000
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   180
      Left            =   2130
      Top             =   2850
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Message Scroller"
      Height          =   195
      Left            =   270
      TabIndex        =   0
      Top             =   1080
      Width           =   3615
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "MsgScroller"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Message Scroller Control
'   written by: Shane Peterson 1997
'   traduit par Antoine de Montgolfier 1998
'
' This control is a message displaying control which
' allows multiple messages to be displayed in a scrolling
' presentation.  Messages can be Added or Deleted from
' the control while messages are being displayed.
'
'Ce contrle permet d'afficher des messages. Il authorise
'l'affichage de plusieurs messages, et donne un effet de scrolling
'(glissement, pour les puristes !)
'Des messages peuvent tre ajouts ou retirs
'pendant que d'autres s'affichent
'
'Mthodes :
'   1) Add_message - Ajoute un message dans la "queue" (liste) des messages
'   2) Remove_message - Retire un message
'   3) Scroll - Dmarre ou arrte le dfilement
'
'Proprits :
'   1) Border - Dtermine si le contrle a ou non une bordure
'   2) Backcolor - Dtermine la couleur d'arrire-plan du contrle
'   3) Forecolor - Dtermine la couleur du texte
'   4) Font - Dtermine la taille et la police des messages
'   5) ScrollInterval - Temps en millisecondes entre les dplacements du texte
'   6) ScrollSpeed - Taille en Twips entre chaque dplacement du texte
'
'   En cliquant sur le contrle, on arrte le dfilement des messages.
'   Pour reprendre le dfilment, il suffit de recliquer
'

Option Explicit

Public Enum SPBorderStyle
    [None] = 0
    [Fixed Single] = 1
End Enum


'Valeurs par dfaut des proprits
Const m_def_Border = [None]
Const m_def_ScrollSpeed = 50
Const m_def_ScrollInterval = 180

Const m_def_Enabled = 0

'Variables correspondant aux proprits
Dim m_Border As SPBorderStyle
Dim m_ScrollSpeed As Integer
Dim m_ScrollInterval As Integer
Dim m_Enabled As Boolean

Dim MsgIdx As Integer

Dim MsgCol As New Collection

Dim MsgHeight As Integer
Dim stop_scroll As Boolean


Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = Label1.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    Label1.BackColor() = New_BackColor
    UserControl.BackColor = New_BackColor
    PropertyChanged "BackColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = Label1.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    Label1.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    PropertyChanged "Enabled"
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = Label1.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set Label1.Font = New_Font
    PropertyChanged "Font"
End Property


Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
     
End Sub


Private Sub Label1_Click()

    'Dmarre ou arrte le scrolling
    If stop_scroll = True Then
        stop_scroll = False
        Timer1.Enabled = True
    Else
        stop_scroll = True
    End If
    
End Sub

Private Sub Timer1_Timer()

    ' Se dplace dans la collection des messages
    
    If stop_scroll Then
        Timer1.Enabled = False
    Else
        DoEvents
        Label1.Top = Label1.Top - m_ScrollSpeed
        DoEvents
    
        If Label1.Top < -MsgHeight Then ' Message has left view
            If MsgCol.Count > 0 Then
                MsgIdx = MsgIdx + 1
                If MsgIdx > MsgCol.Count Then
                    MsgIdx = 1
                Else
                End If
                ' get next message in collection
                Label1.Caption = MsgCol.Item(MsgIdx)
                MsgHeight = Label1.Height
                Label1.Top = UserControl.ScaleHeight
            Else
            End If
        Else
        End If
    End If

End Sub

Private Sub UserControl_Click()

    ' Dmarre ou arrte le scrolling
    If stop_scroll = True Then
        stop_scroll = False
        Timer1.Enabled = True
    Else
        stop_scroll = True
    End If
    
End Sub

Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_UserMemId = -552

    ' Affiche la boite de dialogue "A propos de" en mode de conception
    dlgAbout.Show vbModal
    Unload dlgAbout
    Set dlgAbout = Nothing
    
End Sub


Private Sub UserControl_InitProperties()

    'Initialisation des proprits

    m_Enabled = m_def_Enabled
    
    Label1.Left = 0
    Label1.Top = 0
    Label1.Height = UserControl.ScaleHeight
    Label1.Width = UserControl.ScaleWidth
    
    
    stop_scroll = False
    m_ScrollSpeed = m_def_ScrollSpeed
    m_ScrollInterval = m_def_ScrollInterval
    
    Timer1.Interval = m_ScrollInterval
    
    m_Border = m_def_Border
    UserControl.BorderStyle = m_def_Border
    
End Sub

'Charge les valeurs des proprits depuis "l'endroit de stockage"
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    Label1.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    Label1.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_ScrollSpeed = PropBag.ReadProperty("ScrollSpeed", m_def_ScrollSpeed)
    m_ScrollInterval = PropBag.ReadProperty("ScrollInterval", m_def_ScrollInterval)
    m_Border = PropBag.ReadProperty("Border", m_def_Border)
    
    
    UserControl.BorderStyle = m_Border
   
    
    ' Cache l'tiquette quand on est est en mode d'excution
    If Ambient.UserMode = True Then
        Label1.Caption = ""
    Else
        Label1.Caption = "Message Scroller"
    End If
    
End Sub

Private Sub UserControl_Resize()
    
    Label1.Top = 0
    Label1.Left = 0
    Label1.Height = UserControl.ScaleHeight
    Label1.Width = UserControl.ScaleWidth
    
End Sub

'Ecrit les valeurs des proprits dans "l'endroit de stockage"
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", Label1.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", Label1.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("ScrollSpeed", m_ScrollSpeed, m_def_ScrollSpeed)
    Call PropBag.WriteProperty("ScrollInterval", m_ScrollInterval, m_def_ScrollInterval)
    Call PropBag.WriteProperty("Border", m_Border, m_def_Border)

End Sub

Public Function Scroll()

    'Mthode pour faire le dfilement
    'Dmarre ou arrte le scrolling des messages dans la "queue" (liste) des messages
    If Timer1.Enabled Then
        Timer1.Enabled = False
        stop_scroll = True
    Else
        stop_scroll = False
        If MsgCol.Count > 0 Then
            If MsgIdx = 0 Then
                MsgIdx = 1
            Else
            End If
            
            Label1.Caption = MsgCol.Item(MsgIdx)
            MsgHeight = Label1.Height
            Timer1.Enabled = True
        Else
        End If
    End If
    
End Function

Public Property Get ScrollSpeed() As Integer
Attribute ScrollSpeed.VB_Description = "The amout the scroll  text moves for each ScrollInterval (in Twips)"
    ScrollSpeed = m_ScrollSpeed
End Property

Public Property Let ScrollSpeed(ByVal New_ScrollSpeed As Integer)
    m_ScrollSpeed = New_ScrollSpeed
    PropertyChanged "ScrollSpeed"
End Property

Public Property Get ScrollInterval() As Integer
Attribute ScrollInterval.VB_Description = "How frequent the scroll text moves in Milliseconds."
    ScrollInterval = m_ScrollInterval
End Property

Public Property Let ScrollInterval(ByVal New_ScrollInterval As Integer)
    m_ScrollInterval = New_ScrollInterval
    PropertyChanged "ScrollInterval"
    
    Timer1.Interval = m_ScrollInterval
End Property


Public Function Add_Message(msgtext As String, msgkey As String) As Boolean

    'Ajoute un message dans la collection des messages
    
    On Error GoTo Add_Error
    
    Add_Message = True
    
    If msgtext = "" Or msgkey = "" Then
        Add_Message = False
    Else
        MsgCol.Add msgtext, msgkey
    End If
    
    Exit Function

Add_Error:
    If Err = 457 Then   'Si on essaie d'ajouter un cl qui existe dj
        Add_Message = False
        Resume Next
    Else
    End If
End Function

Public Function Remove_Message(msgkey As String) As Boolean

    'Retire un message de la collection des messages
    
    On Error GoTo Remove_error
    
    Remove_Message = True
    
    If msgkey = "" Then
        Remove_Message = False
    Else
        MsgCol.Remove msgkey
    End If
    
    Exit Function
    
Remove_error:
    If Err = 5 Then ' Si on essaie de retirer une cl qui n'existe pas
        Remove_Message = False
        Resume Next
    Else
    End If
    
End Function
Public Property Get Border() As SPBorderStyle
Attribute Border.VB_Description = "BorderStyle of control."
    Border = m_Border
End Property

Public Property Let Border(ByVal New_Border As SPBorderStyle)
    m_Border = New_Border
    PropertyChanged "Border"
    
    UserControl.BorderStyle = m_Border

End Property

